=== debian/changelog ===
openqa (4.6.1712926289.b0d689b52-2) unstable; urgency=medium

  * switch to patching assetpack.def for local assets
  * multi-dropdown-navbar is now bundled by upstream
  * libjs-cropper is not being used, so drop it

 -- Philip Hands <phil@hands.com>  Sun, 19 May 2024 11:58:55 +0200

openqa (4.6.1712926289.b0d689b52-1) unstable; urgency=medium

  * Update to new upstream version 4.6.1712926289.b0d689b52.
  * add `geekotest` group (see README.Debian)
  * ensure that package builds twice (closes: #1049709)
  * apparmor: additional worker perms
  * use xtigervncviewer in VNC viewer example

 -- Philip Hands <phil@hands.com>  Thu, 25 Apr 2024 10:59:29 +0200
