=== debian/changelog ===
openqa (4.6.1732034221.ae34b08ff-2) unstable; urgency=medium

  [ Roland Clobus ]
  * use Debian changelog to discover a version to show (closes: 1077069)

  [ Philip Hands ]
  * Remove cropper.css (it is unused)
  * avoid running tidy tests during build

 -- Philip Hands <phil@hands.com>  Tue, 08 Apr 2025 09:30:02 +0200

openqa (4.6.1732034221.ae34b08ff-1) unstable; urgency=medium

  [ Philip Hands ]
  * Update to new upstream version 4.6.1732034221.ae34b08ff.
  * ensure node-bootstrap provides libjs-bootstrap5 (closes: 1091155, 1091141)
  * install openqa-enqueue-git-auto-update
  * bootstrap now depends on popper2
  * add node-ace-builds depends
  * use the binary package version for the depends
  * switch to node_modules/_u_s_{nodejs,javascript} symlinks
  * apparmor updates

  [ Roland Clobus ]
  * Debian specific documentation

 -- Philip Hands <phil@hands.com>  Thu, 23 Jan 2025 11:47:03 +0100
