=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
            Hideki Yamane <henrich@debian.org>,
 Build-Depends: debhelper-compat (= 13),
                debhelper (>= 13.11.6),
+               dh-sequence-nodejs,
                dh-exec,
                os-autoinst,
                systemd-dev,
@@ -16,7 +17,6 @@
 ### Bug#839569
 #              libselenium-remote-driver-perl (>= 1.0),
 ### for test&runtime
-#               libaliased-perl,
                libarchive-extract-perl,
                libbsd-resource-perl,
 #               libcache-cache-perl,
@@ -82,6 +82,9 @@
                libwww-perl,
                perl,
                libminion-perl (>= 10.25),
+               node-d3,
+               node-dagre-d3-renderer,
+               node-anser,
 ### for testcases
                libperl-critic-perl <!nocheck>,
                libperl-critic-community-perl <!nocheck>,
@@ -112,18 +115,23 @@
                libfilesys-df-perl <!nocheck>,
                libfile-map-perl <!nocheck>,
                libtext-glob-perl <!nocheck>,
+               libaliased-perl <!nocheck>,
+               libarchive-tools <!nocheck>,
 #              for avoiding assetpack downloads
                fonts-fork-awesome,
                fonts-roboto-fontface,
                libjs-chosen,
                libjs-jquery-datatables,
-               node-bootstrap,
+               node-bootstrap (>= 5.3.3+dfsg-1~),
                libjs-codemirror,
                libjs-jquery (>= 3.6.0),
                libjs-jquery-timeago,
-               libjs-popper.js (>= 1.16.1),
+               node-popper2,
                node-jquery-ujs,
-               libcode-tidyall-perl,
+               node-ace-builds,
+# The following is just for testing behaviour relative to new upstream versions.
+# Never define profiles 'x-with-npm' or 'x-npm-only' for real package builds.
+               npm <x-with-npm>,
 Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://open.qa
@@ -157,9 +165,13 @@
          libjs-codemirror,
          libjs-jquery,
          libjs-jquery-timeago,
-         libjs-popper.js,
+         node-popper2,
          node-jquery-ujs (>= 1.2.3-1),
-         node-bootstrap,
+         node-bootstrap (>= 5.3.3+dfsg-1~),
+         node-ace-builds,
+         node-d3,
+         node-dagre-d3-renderer,
+         node-anser,
 Recommends: apparmor-profiles, apparmor-utils,
             apache2, logrotate,
             libdbd-pg-perl,
@@ -243,7 +255,7 @@
          libconfig-inifiles-perl,
          libdata-dump-perl,
          libmojolicious-perl (>= 9.34),
-         openqa-common (= ${source:Version}),
+         openqa-common (= ${binary:Version}),
 Suggests: python3,
 Description: automatic Operating System testing framework (utilities)
  This package includes scripts such as 'openqa-cli' and 'openqa-clone-job' to
@@ -292,10 +304,3 @@
 Multi-Arch: foreign
 Section: doc
 Depends: ${misc:Depends},
-Description: automatic Operating System testing framework - documentation
- Documentation for openQA (and the associated os-autoinst test engine), covering
- topics including: installation, configuration, and basic test writing.
- .
- openQA is a testing framework that allows you to run tests on pretty-much
- anything that you can 'remotely' control. For instance, a VM that can be
- accessed via VNC.
